#if IG_C111 || IG_C301 // Auto generated by AddMacroForInstantGameFiles.exe

using System.Linq;
using UnityEngine;
using UnityEditor.IMGUI.Controls;
using UnityEditor;

namespace Unity.AutoStreaming
{
    internal class ASAnimationUI : TabBase<ASAnimationTreeView, ASAnimationTreeDataItem>
    {
        protected override MultiColumnHeaderState CreateColumnHeaderState(float treeViewWidth)
        {
            return ASAnimationTreeView.CreateDefaultMultiColumnHeaderState(treeViewWidth);
        }

        protected override void InitTreeView(MultiColumnHeader multiColumnHeader)
        {
            var treeModel = new TreeModelT<ASAnimationTreeDataItem>(ASMainWindow.Instance.AnimationData);
            m_TreeView = new ASAnimationTreeView(m_TreeViewState, multiColumnHeader, treeModel);
        }

        protected override void OnToolbarGUI(Rect rect)
        {
            GUILayout.BeginArea(rect);

            using (new EditorGUILayout.HorizontalScope())
            {
                GUILayout.Space(5);

                if (GUILayout.Button("Sync Animations", s_MiniButton, GUILayout.Width(120)))
                {
                    SyncAnimationes();
                }

                GUILayout.Space(5);
                m_TreeView.searchString = m_SearchField.OnToolbarGUI(m_TreeView.searchString, GUILayout.Width(200));

                GUILayout.FlexibleSpace();

                string statusReport = "";
                var allAnimationes = AutoStreamingSettings.animations;
                var onDemandDownloadItems = allAnimationes.Where(x => x.onDemandDownload);
                statusReport = string.Format("Placeholder: {0}/{1}, RT: {2}, Warning: {3}",
                    onDemandDownloadItems.Count(),
                    allAnimationes.Length,
                    EditorUtility.FormatBytes(onDemandDownloadItems.Select(x => (long)x.runtimeMemory).Sum()),
                    onDemandDownloadItems.Select(x => (x.warningFlag != 0 ? 1 : 0)).Sum());
                GUILayout.Label(statusReport);
            }
            GUILayout.EndArea();
        }

        void SyncAnimationes()
        {
            ASUtilities.GenerateAddressablePathsText();
            AutoStreamingSettings.SyncAnimations();
            ASMainWindow.Instance.AnimationData = null;
            m_TreeViewInitialized = false;
        }
    }
}

#endif  // IG_C111 || IG_C301, Auto generated by AddMacroForInstantGameFiles.exe
