#if IG_C111 || IG_C301 // Auto generated by AddMacroForInstantGameFiles.exe

using System.Collections.Generic;
using System.IO;
using UnityEngine;
using YamlDotNet.Serialization;
using YamlDotNet.Serialization.NamingConventions;

namespace Unity.AutoStreaming
{
    public class UnityHash
    {
        public string serializedVersion;
        public string Hash;
    }
    public class UnityABHash
    {
        public UnityHash AssetFileHash;
        public UnityHash TypeTreeHash;
    }

    public class UnityClassType
    {
        public int Class;
        public System.Object Script;
    }

    public class UnitySerializeReferenceClassIdentifier
    {
        public string AssemblyName;
        public string ClassName;
    }

    public class UnityABManifest
    {
        public string ManifestFileVersion;
        public string CRC;
        public UnityABHash Hashes;
        public string HashAppended;
        public List<UnityClassType> ClassTypes;
        public List<UnitySerializeReferenceClassIdentifier> SerializeReferenceClassIdentifiers;
        public List<string> Assets;
        public List<string> Dependencies;
    }

    public class ParseABManifest
    {
        public static UnityABManifest DoParseFile(string filePath)
        {
            var deserializer = new DeserializerBuilder()
                .WithNamingConvention(new NullNamingConvention())
                .Build();

            StreamReader streamReader = new StreamReader(filePath);
            return deserializer.Deserialize<UnityABManifest>(streamReader);
        }

        public static List<UnityABManifest> DoParseFolder(string folderPath)
        {
            Debug.Log("DoParseFolder " + folderPath);

            List<UnityABManifest> abms = new List<UnityABManifest>();
            int assetCount = 0;

            var filePaths = Directory.GetFiles(folderPath, "*.manifest", SearchOption.AllDirectories);
            foreach (var filePath in filePaths)
            {
                UnityABManifest abm;
                try
                {
                    abm = DoParseFile(filePath);
                }
                catch (System.Exception)
                {
                    continue;
                }
                assetCount += abm.Assets.Count;
                abms.Add(abm);
            }

            using (StreamWriter outTxt = new StreamWriter(Path.Combine(folderPath, "CustomSearch.txt")))
            {
                outTxt.WriteLine(assetCount);
                foreach (var abm in abms)
                {
                    foreach (var assetPath in abm.Assets)
                        outTxt.WriteLine(assetPath);
                }
            }

            return abms;
        }
    }
}

#endif  // IG_C111 || IG_C301, Auto generated by AddMacroForInstantGameFiles.exe
