#if IG_C111 || IG_C301 // Auto generated by AddMacroForInstantGameFiles.exe

using System.Linq;
using UnityEngine;
using UnityEditor.IMGUI.Controls;
using UnityEditor;

namespace Unity.AutoStreaming
{
    internal class ASMeshUI : TabBase<ASMeshTreeView, ASMeshTreeDataItem>
    {
        protected override MultiColumnHeaderState CreateColumnHeaderState(float treeViewWidth)
        {
            return ASMeshTreeView.CreateDefaultMultiColumnHeaderState(treeViewWidth);
        }

        protected override void InitTreeView(MultiColumnHeader multiColumnHeader)
        {
            var treeModel = new TreeModelT<ASMeshTreeDataItem>(ASMainWindow.Instance.MeshData);
            m_TreeView = new ASMeshTreeView(m_TreeViewState, multiColumnHeader, treeModel);
        }

        protected override void OnToolbarGUI(Rect rect)
        {
            GUILayout.BeginArea(rect);

            using (new EditorGUILayout.HorizontalScope())
            {
                GUILayout.Space(5);

                if (GUILayout.Button("Sync Meshes", s_MiniButton, GUILayout.Width(100)))
                {
                    SyncMeshes();
                }

                GUILayout.Space(5);
                m_TreeView.searchString = m_SearchField.OnToolbarGUI(m_TreeView.searchString, GUILayout.Width(200));

                GUILayout.FlexibleSpace();

                string statusReport = "";
                var allMeshes = AutoStreamingSettings.meshes;
                var onDemandDownloadItems = allMeshes.Where(x => x.onDemandDownload);
                statusReport = string.Format("Placeholder: {0}/{1}, RT: {2}, Warning: {3}",
                    onDemandDownloadItems.Count(),
                    allMeshes.Length,
                    EditorUtility.FormatBytes(onDemandDownloadItems.Select(x => (long)x.runtimeMemory).Sum()),
                    onDemandDownloadItems.Select(x => (x.warningFlag != 0 ? 1 : 0)).Sum());
                GUILayout.Label(statusReport);
            }
            GUILayout.EndArea();
        }

        void SyncMeshes()
        {
            ASUtilities.GenerateAddressablePathsText();
            AutoStreamingSettings.SyncMeshes();
            ASMainWindow.Instance.MeshData = null;
            m_TreeViewInitialized = false;
        }
    }
}

#endif  // IG_C111 || IG_C301, Auto generated by AddMacroForInstantGameFiles.exe
