#if IG_C111 || IG_C301 // Auto generated by AddMacroForInstantGameFiles.exe

#if UNITY_ADDRESSABLES
using System.Collections.Generic;
using UnityEditor.AddressableAssets.Settings;
using UnityEditor;
using UnityEditor.AddressableAssets;
using UnityEngine.U2D;
using System.Reflection;
using System;

namespace Unity.AutoStreaming
{
    public class AddressableSpriteAtlasUtils
    {
        internal static void ReplaceAdressableSpriteAtlas(bool usePlaceholder)
        {
            var addressableAssetSettings = AddressableAssetSettingsDefaultObject.Settings;
            if (addressableAssetSettings == null)
                return;


            HashSet<String> texUsePlaceholder = new HashSet<string>();
            if (usePlaceholder)
            {
                foreach (var tex in AutoStreamingSettings.textures)
                {
                    if (tex.usePlaceholder)
                        texUsePlaceholder.Add(tex.assetPath);
                }

            }

            foreach (var group in addressableAssetSettings.groups)
            {
                // Skip "Built In Data" group.
                if (group.Name.StartsWith("Built In Data"))
                    continue;

                List<KeyValuePair<AddressableAssetEntry, AddressableAssetEntry>> replacements = new List<KeyValuePair<AddressableAssetEntry, AddressableAssetEntry>>();
                foreach (var entry in group.entries)
                {
                    Type assetType = AssetDatabase.GetMainAssetTypeAtPath(entry.AssetPath);
                    if (typeof(SpriteAtlas) == assetType && (entry.AssetPath.StartsWith("Assets/AutoStreamingData/Placeholders") ^ usePlaceholder))
                    {
                        string path = AssetDatabase.GUIDToAssetPath(entry.guid);
                        string replacementPath = "";
                        if (usePlaceholder)
                        {
                            if (!texUsePlaceholder.Contains(path))
                                continue;
                            replacementPath = AutoStreamingSettings.AssetPathToPlaceholderPath(path);
                        }
                        else
                        {
                            replacementPath = AutoStreamingSettings.PlaceholderPathToAssetPath(path);
                        }

                        Type entryType = typeof(AddressableAssetEntry);
                        ConstructorInfo constructor = entryType.GetConstructor(BindingFlags.NonPublic | BindingFlags.Instance, null, new Type[] { typeof(String), typeof(String), typeof(AddressableAssetGroup), typeof(bool) }, null);

                        AddressableAssetEntry e = (AddressableAssetEntry)constructor.Invoke(new object[] { AssetDatabase.AssetPathToGUID(replacementPath), entry.address, group, false });
                        e.labels.UnionWith(entry.labels);
                        replacements.Add(new KeyValuePair<AddressableAssetEntry, AddressableAssetEntry>(entry, e));
                    }
                }

                foreach (var pair in replacements)
                {
                    group.RemoveAssetEntry(pair.Key);
                    Type groupType = typeof(AddressableAssetGroup);
                    MethodInfo addMethod = groupType.GetMethod("AddAssetEntry", BindingFlags.NonPublic | BindingFlags.Instance, null, new Type[] { typeof(AddressableAssetEntry), typeof(bool) }, null);
                    addMethod.Invoke(group, new object[] { pair.Value, true });
                }
            }

            AssetDatabase.SaveAssets();
        }
    }
}
#endif // UNITY_ADDRESSABLES

#endif  // IG_C111 || IG_C301, Auto generated by AddMacroForInstantGameFiles.exe
