#if IG_C111 || IG_C301 // Auto generated by AddMacroForInstantGameFiles.exe

using UnityEngine;
using UnityEditor.IMGUI.Controls;

namespace Unity.AutoStreaming
{
    internal abstract class TabBase<T, U>  where T : TreeViewBaseT<U> where U : TreeDataItem
    {
        protected T m_TreeView;
        protected TreeViewState m_TreeViewState;  // Serialized in the window layout file so it survives assembly reloading.
        protected MultiColumnHeaderState m_MultiColumnHeaderState;
        protected SearchField m_SearchField;
        protected bool m_TreeViewInitialized = false;

        protected static GUIStyle s_MiniButton = new GUIStyle("miniButton");

        protected Rect TabToolbarRect
        {
            get => new Rect(0, ASMainWindow.Instance.ModeTabRect.yMax, ASMainWindow.Instance.position.width, 20f);
        }

        protected Rect TreeViewRect
        {
            get => new Rect(0, TabToolbarRect.yMax, ASMainWindow.Instance.position.width, ASMainWindow.Instance.position.height - TabToolbarRect.yMax);
        }

        public void Init()
        {
            if (m_TreeViewInitialized)
                return;

            if (m_TreeViewState == null)
                m_TreeViewState = new TreeViewState();

            bool firstInit = (m_MultiColumnHeaderState == null);

            var headerState = CreateColumnHeaderState(TreeViewRect.width);
            if (MultiColumnHeaderState.CanOverwriteSerializedFields(m_MultiColumnHeaderState, headerState))
                MultiColumnHeaderState.OverwriteSerializedFields(m_MultiColumnHeaderState, headerState);
            m_MultiColumnHeaderState = headerState;

            var multiColumnHeader = new ASMultiColumnHeader(headerState);
            if (firstInit)
                multiColumnHeader.ResizeToFit();

            InitTreeView(multiColumnHeader);

            m_SearchField = new SearchField();
            m_SearchField.downOrUpArrowKeyPressed += m_TreeView.SetFocusAndEnsureSelectedItem;

            m_TreeViewInitialized = true;
        }

        protected abstract MultiColumnHeaderState CreateColumnHeaderState(float treeViewWidth);
        protected abstract void InitTreeView(MultiColumnHeader multiColumnHeader);

        public virtual void OnGUI()
        {
            OnToolbarGUI(TabToolbarRect);
            m_TreeView.OnGUI(TreeViewRect);
        }

        protected abstract void OnToolbarGUI(Rect rect);
    }
}

#endif  // IG_C111 || IG_C301, Auto generated by AddMacroForInstantGameFiles.exe
