#if IG_C111 || IG_C301 // Auto generated by AddMacroForInstantGameFiles.exe

using System;
using System.IO;
using System.Net;
using UnityEditor;
using UnityEngine;

namespace Unity.AutoStreaming.CloudContentDelivery
{
    [Serializable]
    internal class Project
    {
        public string AppId;
        public string AppSecret;
        public string UnityProjectGuid;
        public string Provider;
        public bool Status;

        class WebExceptionResponse 
        {
            public int code;
            public string[] details;
            public string reason;
        }

        public static Project LoadProject(string uosAuthorizationToken)
        {
            string url = string.Format("{0}api/v1/users/me/uos/", UOSInfo.ApiHost);
            try
            {
                using (HttpWebResponse resp = (HttpWebResponse) Util.GetHttpWebRequest4UOSThreaded(uosAuthorizationToken, url, "GET").GetResponse())
                {
                    if (resp.StatusCode.Equals(HttpStatusCode.OK))
                    {
                        string strJson;
                        using (Stream stream = resp.GetResponseStream())
                        {
                            using (StreamReader reader = new StreamReader(stream))
                            {
                                strJson = reader.ReadToEnd();
                            }
                        }
                        var obj = JsonUtility.FromJson<Project>(strJson);
                        return obj;
                    }
                    else
                    {
                        Debug.LogError("Failed loading UOS App Info.");
                    }
                }
            }
            catch (WebException e)
            {
                var errMsg = e.Message;
                string strJson;
                using (Stream stream = e.Response.GetResponseStream())
                {
                    using (StreamReader reader = new StreamReader(stream))
                    {
                        strJson = reader.ReadToEnd();
                    }
                }
                var resp = JsonUtility.FromJson<WebExceptionResponse>(strJson);
                if (resp != null)
                {
                    errMsg = resp.reason + ": ";
                    foreach (var c in resp.details)
                    {
                        errMsg += " " + c;
                    }
                }
                EditorUtility.DisplayDialog("Load UOS App Info Error", errMsg, "OK");
            }
            catch (Exception e)
            {
                EditorUtility.DisplayDialog("Load UOS App Info Error", e.Message, "OK");
            }
            return null;
        }
    }
}

#endif  // IG_C111 || IG_C301, Auto generated by AddMacroForInstantGameFiles.exe
