#if IG_C111 || IG_C301 // Auto generated by AddMacroForInstantGameFiles.exe

using System;
using System.IO;
using System.Net;
using UnityEditor;
using UnityEngine;

namespace Unity.AutoStreaming.CloudContentDelivery
{
    [Serializable]
    internal class Release
    {
        public string releaseid;
        public int release_num;
        public string created_by;
        public string entries_link;
        public string content_hash;
        public string content_size;

        public static Release[] LoadReleases(string uosAuthorizationToken, string bucketUuid)
        {
            string url = string.Format("{0}api/v1/buckets/{1}/releases/?page={2}&per_page={3}", UOSInfo.ApiHost, bucketUuid, 1, 5000);

            try
            {
                using (HttpWebResponse resp = (HttpWebResponse)Util.GetHttpWebRequest4UOSThreaded(uosAuthorizationToken, url, "GET").GetResponse())
                {
                    if (resp.StatusCode.Equals(HttpStatusCode.OK))
                    {
                        string strJson;
                        using (Stream stream = resp.GetResponseStream())
                        {
                            using (StreamReader reader = new StreamReader(stream))
                            {
                                strJson = reader.ReadToEnd();
                            }
                        }
                        return JsonUtility.FromJson<ReleasesRoot>("{\"Releases\":" + strJson + "}").Releases;
                    }
                    else
                    {
                        Debug.LogError("Failed loading release.");
                    }
                }
            }
            catch (Exception e)
            {
                EditorUtility.DisplayDialog("Load Releases Error", e.Message, "OK");
            }
            return null;
        }

        public static string CreateRelease(string uosAuthorizationToken, string bucketUuid, string notes)
        {
            EditorUtility.DisplayProgressBar("AutoStreaming Remote Deploy", "Create Release", 0.7f);

            if (string.IsNullOrEmpty(bucketUuid))
            {
                EditorUtility.ClearProgressBar();
                return "";
            }
            string url = string.Format("{0}api/v1/buckets/{1}/releases/", UOSInfo.ApiHost, bucketUuid);
            string requestBody = "{\"notes\": \"" + notes + "\"}";
            try
            {
                using (HttpWebResponse response = (HttpWebResponse)Util.GetHttpWebRequest4UOSThreaded(uosAuthorizationToken, url, "POST", requestBody).GetResponse())
                {
                    if (response.StatusCode.Equals(HttpStatusCode.OK))
                    {
                        string strJson;
                        using (Stream stream = response.GetResponseStream())
                        {
                            using (StreamReader reader = new StreamReader(stream))
                            {
                                strJson = reader.ReadToEnd();
                            }
                        }
                        EditorUtility.ClearProgressBar();
                        return JsonUtility.FromJson<Release>(strJson).releaseid;
                    }
                    else
                    {
                        Debug.LogError("Failed creating release.");
                    }
                }
            }
            catch (Exception e)
            {
                EditorUtility.DisplayDialog("Create Release Error", e.Message, "OK");
            }
            EditorUtility.ClearProgressBar();
            return "";
        }
    }

    [Serializable]
    internal class ReleasesRoot
    {
        public Release[] Releases;
    }
}

#endif  // IG_C111 || IG_C301, Auto generated by AddMacroForInstantGameFiles.exe
